<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG2</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG2 del grupo T7<br>
			Titulo: TG2. Evaluar y comparar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Descripcion de las tecnologias</a></li>
			<li><a href="#3">3. Criterios de comparacion</a></li>
			<li><a href="#4">4. Evaluacion de los criterios por categoria</a></li>
			<li><a href="#5">5. Comparacion de las tecnologias</a></li>
			<li><a href="#6">6. Recomendaciones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
		<p>T7</p>
			<p>Javier Hernández Ortiz</p>
			<p>Javier Velilla Martinez</p>
			<p>Raul Benito Rodriguez</p>
			<p>Javier Palanques de Maria</p>
			<p>David Fuentes Miguel</p>
			
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
				<a href="https://gitlab.com/dte2020/t7/tg02/">Enlace al repositorio de GitLab</a>
			<h3>1.3 Burndown chart</h3>
			<img src="burndownTG2.PNG">
			<h3>1.4 Presentacion del trabajo</h3>
			<a href="tg2.pptx">Presentacion con diapositivas del trabajo TG2</a></p>
		</section>
		<section id="2">
			<h2>2. Descripcion de las tecnologias</h2>
			<h3>2.1 DESCRIPCIÓN DE LA TECNOLOGIA 1: CIRCLE CI</h3>
			<p>Circle CI permite crear una tubería cada vez que se confirma el código. Después ejecuta o prueba esa tubería en una máquina virtual, lo que le permite 
			probar ese código o confirmación.
            En caso de fallo de la tubería, el equipo que manipule el programa recibiría una notificación con las especificaciones del error, para atajarlo cuanto antes.</p>
            <a href="https://d3r49iyjzglexf.cloudfront.net/illustrations/illu_howcciworks-5e2dd5fa6563535f380c890665a1c0d663ad0bcf57a177e8d55f0d124dcdc5c0.png">Imagen de interés</a>
            
			<h3>2.2 DESCRIPCIÓN DE LA TECNOLOGIA 2: GITLAB CI</h3>
			<p>GitLab CI es una plataforma que puede comprometer el código de los usuarios que lo utilicen,  permite control de versiones, hacer revisiones de código, 
			y también permite pruebas de integración, de construcción y de despliegue de código.</p>
			<a href="https://miro.medium.com/max/1400/0*KTs49RKq1q2mPXMG.png">Imagen de interés</a>
		</section>
		<section id="3">
			<h2>3. Criterios de comparacion</h2>
		
			<h3>3.1 Categoria A: General</h3>
			<h4>3.1.1 Criterio A.1: Idioma de la herramienta </h4>
			<ul>
				<li>Nombre del criterio: Idioma.</li>
				<li>Descripcion:: Idiomas admitidos por las herramientas a comparar.</li>
				<li>Tipo de valor: String.</li>
			</ul>
			<h4>3.1.2 Criterio A.2: Dispositivos compatibles</h4>
			<ul>
				<li>Nombre del criterio: Dispositivos</li>
				<li>Descripcion: Tipo de dispositivos compatibles con las herramientas.</li>
				<li>Tipo de valor: String</li>
			</ul>
			<h4>3.1.3 Criterio A.3: Precio de las licencias</h4>
			<ul>
				<li>Nombre del criterio: Precio</li>
				<li>Descripcion: Precio para poder usar las herramientas.</li>
				<li>Tipo de valor: Numérico</li>
			</ul>
			<h4>3.1.4 Criterio A.4: Cantidad de gente que puede utilizar las herramientas</h4>
			<ul>
				<li>Nombre del criterio: Cantidad de usuarios</li>
				<li>Descripcion: Número de la cantidad de usuarios que pueden trabajar en un mismo proyecto.</li>
				<li>Tipo de valor: String(Puede ser ilimitado)</li>
			</ul>
			<h4>3.1.5 Criterio A.5: Formación</h4>
			<ul>
				<li>Nombre del criterio: Formación</li>
				<li>Descripcion: Ofrece cursos de formación para nuevos usuarios.</li>
				<li>Tipo de valor: Boolean(S/N)</li>
			</ul>
			<h4>3.1.6 Criterio A.6: Asistencia</h4>
			<ul>
				<li>Nombre del criterio: Asistencia</li>
				<li>Descripcion:La herramienta cuenta con asistencia ininterrumpida o no.</li>
				<li>Tipo de valor: Boolean(S/N)</li>
			</ul>
			<h4>3.1.7 Criterio A.7: Facilidad de uso de las herramientas</h4>
			<ul>
				<li>Nombre del criterio: Facilidad de uso</li>
				<li>Descripcion:La herramienta es fácil o difícil de usar.</li>
				<li>Tipo de valor: Boolean(F/D)</li>
			</ul>
				<h4>3.1.8 Criterio A.8: Tamaño de empresa recomendado</h4>
			<ul>
				<li>Nombre del criterio: Tamaño empresa</li>
				<li>Descripcion:Para qué tipo de empresas es recomendable usar las herramientas.</li>
				<li>Tipo de valor: String</li>
			</ul>
			<h4>3.1.9 Criterio A.9: Prueba gratuita de la herramienta</h4>
			<ul>
				<li>Nombre del criterio: Tamaño empresa</li>
				<li>Descripcion:La herramienta cuenta con una versión de prueba gratuita o no.</li>
				<li>Tipo de valor: Boolean(S/N)</li>
			</ul>
			<h4>3.1.10 Criterio A.10: Manual de usuario</h4>
			<ul>
				<li>Nombre del criterio: Tamaño empresa</li>
				<li>Descripcion:: La herramienta cuenta con un manual de usuario o no.</li>
				<li>Tipo de valor: Boolean(S/N)</li>
			</ul>
			<h3>3.2 Categoria B: Rendimiento</h3>
			<h4>3.2.1 Criterio B.1: Espacio disponible en las bases de datos de la herramienta</h4>
			<ul>
				<li>Nombre del criterio: Espacio disponible</li>
				<li>Descripcion: Tamaño máximo con el que cuentan los usuarios para poder realizar sus proyectos.</li>
				<li>Tipo de valor: String.</li>
			</ul>
				<h4>3.2.2 Criterio B.2:Tiempos de ejecución</h4>
			<ul>
				<li>Nombre del criterio: Tiempos de ejecución</li>
				<li>Descripcion: Comparativa de tiempos de ejecución entre las herramientas.</li>
				<li>Tipo de valor: String.</li>
			</ul>
			<h4>3.2.3 Criterio B.3: Ejecución simultánea en varios equipos</h4>
			<ul>
				<li>Nombre del criterio: Ejecución simultánea.</li>
				<li>Descripcion: : La herramienta soporta ejecución simultánea en varios equipos o no.</li>
				<li>Tipo de valor: Boolean(S/N).</li>
			</ul>
				<h4>3.2.4 Criterio B.4: Depuración</h4>
			<ul>
				<li>Nombre del criterio: Depuración.</li>
				<li>Descripcion: : La herramienta cuenta con opciones de depuración o no.</li>
				<li>Tipo de valor: Boolean(S/N).</li>
			</ul>
			<h4>3.2.5 Criterio B.5: Despliegue</h4>
			<ul>
				<li>Nombre del criterio: Despliegue.</li>
				<li>Descripcion: : En que entornos se puede desplegar las herramientas (SAAS, Cloud o Web).</li>
				<li>Tipo de valor: String.</li>
			</ul>

			<h3>3.3 Categoria C: Funcionalidades</h3>
			<h4>3.3.1 Criterio C.1: Entrega continua</h4>
			<ul>
				<li>Nombre del criterio: Entrega continua.</li>
				<li>Descripcion: La herramienta cuenta con soporte para la entrega continua o no.</li>
				<li>Tipo de valor: Boolean(S/N).</li>
			</ul>
			<h4>3.3.2 Criterio C.2: Gestión de permisos</h4>
			<ul>
				<li>Nombre del criterio: Entrega continua.</li>
				<li>Descripcion: La herramienta cuenta con soporte para la Gestión de permisos o no.</li>
				<li>Tipo de valor: Boolean(S/N).</li>
			</ul>
			<h4>3.3.3 Criterio C.3: Control de calidad</h4>
			<ul>
				<li>Nombre del criterio:Control de calidad.</li>
				<li>Descripcion: :: La herramienta cuenta con soporte para el control de calidad o no.</li>
				<li>Tipo de valor: Boolean(S/N).</li>
			</ul>
			<h4>3.3.4 Criterio C.4: Gestión de pruebas</h4>
			<ul>
				<li>Nombre del criterio: Gestión de pruebas.</li>
				<li>Descripcion: La herramienta cuenta con soporte para la gestión de pruebas o no.</li>
				<li>Tipo de valor: Boolean(S/N).</li>
			</ul>
			<h4>3.3.5 Criterio C.5: Control de versiones</h4>
			<ul>
				<li>Nombre del criterio: Control de versiones.</li>
				<li>Descripcion: : La herramienta cuenta con soporte para el control de versiones o no.</li>
				<li>Tipo de valor: Boolean(S/N).</li>
			</ul>
		

		</section>

		<section id="4">
			<h2>4. Evaluacion de los criterios por categoria</h2>
			<h3>4.1 Evaluacion de los criterios para la tecnologia Circle CI </h3>
			<table>
				<tr>
					<th>General</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio A.1: Idioma de la herramienta</td>
					<td>Inglés y japonés</td>
				</tr>
				<tr>
					<td>Criterio A.2: Dispositivos compatibles</td>
					<td>Multiplataforma</td>
				</tr>
				<tr>
					<td>Criterio A.3: Precio de las licencias</td>
					<td>30 US$/mes</td>
				</tr>
				<tr>
					<td>Criterio A.4: Cantidad de gente que puede utilizar las herramientas</td>
					<td>Ilimitado</td>
				</tr>
				<tr>
					<td>Criterio A.5: Formación</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.6: Asistencia</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.7: Facilidad de uso de las herramientas</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.8: Tamaño de empresa recomendado</td>
					<td>Empresa de cualquier tamaño</td>
				</tr>
				<tr>
					<td>Criterio A.9: Prueba gratuita de la herramienta</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.10: Manual de usuario</td>
					<td>Sí</td>
				</tr>
				<tr>
					<th>Rendimiento</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio B.1: Espacio disponible en las bases de datos de la herramienta</td>
					<td>Ilimitado</td>
				</tr>
				<tr>
					<td>Criterio B.2: Tiempos de ejecución</td>
					<td>Menor</td>
				</tr>
				<tr>
					<td>Criterio B.3: Ejecución simultánea en varios equipos</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio B.4: Depuración</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio B.5: Despliegue</td>
					<td>SAAS, web y cloud</td>
				</tr>
				<tr>
					<th>Funcionalidades</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio C.1: Entrega continua</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.2: Gestión de permisos</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.3: Control de calidad</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.4: Gestión de pruebas</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.5: Control de versiones</td>
					<td>Sí</td>
				</tr>
				
			</table>

			

			<h3>4.2 Evaluacion de los criterios para la tecnologia GitLab CI</h3>
			<table>
				<tr>
					<th>General</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio A.1: Idioma de la herramienta</td>
					<td>Inglés</td>
				</tr>
				<tr>
					<td>Criterio A.2: Dispositivos compatibles</td>
					<td>Versión escritorio e IOS</td>
				</tr>
				<tr>
					<td>Criterio A.3: Precio de las licencias</td>
					<td>Desde gratis hasta 100US$/mes</td>
				</tr>
				<tr>
					<td>Criterio A.4: Cantidad de gente que puede utilizar las herramientas</td>
					<td>Ilimitado</td>
				</tr>
				<tr>
					<td>Criterio A.5: Formación</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.6: Asistencia</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.7: Facilidad de uso de las herramientas</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.8: Tamaño de empresa recomendado</td>
					<td>Empresa de cualquier tamaño</td>
				</tr>
				<tr>
					<td>Criterio A.9: Prueba gratuita de la herramienta</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio A.10: Manual de usuario</td>
					<td>Sí</td>
				</tr>
				<tr>
					<th>Rendimiento</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio B.1: Espacio disponible en las bases de datos de la herramienta</td>
					<td>Ilimitado</td>
				</tr>
				<tr>
					<td>Criterio B.2: Tiempos de ejecución</td>
					<td>Mayor</td>
				</tr>
				<tr>
					<td>Criterio B.3: Ejecución simultánea en varios equipos</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio B.4: Depuración</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio B.5: Despliegue</td>
					<td>SAAS, web y cloud</td>
				</tr>
				<tr>
					<th>Funcionalidades</th>
					<th>Evaluacion</th>
				</tr>
				<tr>
					<td>Criterio C.1: Entrega continua</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.2: Gestión de permisos</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.3: Control de calidad</td>
					<td>Sí</td>
				</tr>
				<tr>
					<td>Criterio C.4: Gestión de pruebas</td>
					<td>No</td>
				</tr>
				<tr>
					<td>Criterio C.5: Control de versiones</td>
					<td>No</td>
				</tr>
			</table>



		</section>

		<section id="5">
			<h2>5. Comparacion de las tecnologias</h2>
			<table>
				<tr>
					<th>General</th>
					<th>Circle CI</th>
					<th>Gitlab CI</th>
					<th>Comentarios</th>
				</tr>
				<tr>
					<td>Criterio A.1: Idioma de la herramienta</td>
					<td>Inglés y japonés</td>
					<td>Inglés</td>
					<td>Circle CI cuenta con el idioma japonés, lo que le abre más puertas en ese mercado</td>
				</tr>
				<tr>
					<td>Criterio A.2: Dispositivos compatibles</td>
					<td>Multiplataforma</td>
					<td>Versión de escritorio e IOS</td>
					<td>Circle CI es compatible con más plataformas que Gitlab CI</td>
				</tr>
				<tr>
					<td>Criterio A.3: Precio de las licencias</td>
					<td>30 US$/mes</td>
					<td>Desde gratis hasta 100 US$/mes</td>
					<td>Gitlab CI cuenta con una versión gratuita y un rango de precios mayor al de Circle CI</td>
				</tr>
				<tr>
					<td>Criterio A.4: Cantidad de gente que puede utilizar las herramientas</td>
					<td>Ilimitado</td>
					<td>Ilimitado</td>
					<td>Ambas herramientas cuentan con un número de usuarios ilimitado</td>
				</tr>
				<tr>
					<td>Criterio A.5: Formación</td>
					<td>Sí</td>
					<td>Sí</td>
					<td></td>
				</tr>
				<tr>
					<td>Criterio A.6: Asistencia</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambas herramientas cuentan con asistencia técnica</td>
				</tr>
				<tr>
					<td>Criterio A.7: Facilidad de uso de las herramientas</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambas herramientas son fáciles de usar</td>
				</tr>
				<tr>
					<td>Criterio A.8: Tamaño de empresa recomendado</td>
					<td>Empresa de cualquier tamaño</td>
					<td>Empresa de cualquier tamaño</td>
					<td></td>
				</tr>
				<tr>
					<td>Criterio A.9: Prueba gratuita de la herramienta</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambas herramientas cuentan con una prueba gratuita</td>
				</tr>
				<tr>
					<td>Criterio A.10: Manual de usuario</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambas herramientas cuentan con un manual de usuario</td>
				</tr>
				<tr>
					<th>Rendimiento</th>
					<th></th>
				</tr>
				<tr>
					<td>Criterio B.1: Espacio disponible en las bases de datos de la herramienta</td>
					<td>Ilimitado</td>
					<td>Ilimitado</td>
					<td>Ambas herramientas cuentan con un espacio ilimitado en sus bases de datos</td>
				</tr>
				<tr>
					<td>Criterio B.2: Tiempos de ejecución</td>
					<td>Menor</td>
					<td>Mayor</td>
					<td>El tiempo de ejecución es menor en Circle CI</td>
				</tr>
				<tr>
					<td>Criterio B.3: Ejecución simultánea en varios equipos</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambas herramientas cuentan con un sistema de ejecución simultánea en varios equipos</td>
				</tr>
				<tr>
					<td>Criterio B.4: Depuración</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambas herramientas cuentan con una herramienta de depuración</td>
				</tr>
				<tr>
					<td>Criterio B.5: Despliegue</td>
					<td>SAAS, web y cloud</td>
					<td>SAAS, web y cloud</td>
					<td>Ambas herramientas pueden desplegarse tanto en SAAS, como en web, como en cloud</td>
				</tr>
				<tr>
					<th>Funcionalidades</th>
					<th></th>
				</tr>
				<tr>
					<td>Criterio C.1: Entrega continua</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambas herramientas cuentan con un sistema de entrega continua</td>
				</tr>
				<tr>
					<td>Criterio C.2: Gestión de permisos</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambas herramientas cuentan con un sistema de gestión de permisos</td>
				</tr>
				<tr>
					<td>Criterio C.3: Control de calidad</td>
					<td>Sí</td>
					<td>Sí</td>
					<td>Ambas herramientas cuentan con un sistema de control de calidad</td>
				</tr>
				<tr>
					<td>Criterio C.4: Gestión de pruebas</td>
					<td>Sí</td>
					<td>No</td>
					<td>Solo Circle CI cuenta con un sistema de gestión de pruebas</td>
				</tr>
				<tr>
					<td>Criterio C.5: Control de versiones</td>
					<td>Sí</td>
					<td>No</td>
					<td>Solo Circle CI cuenta con un sistema de control de versiones</td>
				</tr>
				
			</table>
		</section>

		<section id="6">
			<h2>6. Recomendaciones</h2>
			<h3>6.1 Situacion A</h3>
			<h4>6.1.1 Descripcion de la situacion</h4>
			<p>Una empresa toma la decisión de realizar una aplicación/un programa en el innovador lenguaje Python. Este programa deberá realizarse en tiempo récord, dejando la gestión de este a los programadores y a su coordinador del proyecto. Se asigna un total de 50 programadores a esta tarea.</p>
			<h4>6.1.2 Recomendacion de la tecnología a utilizar</h4>
			<p>La tecnología que se recomienda es CircleCI, ya que, como podemos observar en la tabla, CircleCI posee un sistema más centrado en la velocidad del desarrollo, prueba e implementación del software, centrándose muy poco en la gestión de errores, con una configuración sencilla y con un sistema integrado de GitHub, por lo que es idóneo para esta situación.</p>
			<table>
				<tr>
					<th>Criterios</th>
					<th>Ventajas CircleCI</th>
					<th>Ventajas GitLab</th>
				</tr>
				<tr>
					<td>Lenguaje Python</td>
					<td>Se incluye Python en su sistema</td>
					<td>Proporciona soporte a los programas en Python</td>
				</tr>
				<tr>
					<td>Realización en tiempo récord</td>
					<td>Posee un sistema de compilación rápido, que ayuda a liberar rápidamente el código</td>
					<td>Su sistema se centra en la prueba, soporte y detección de errores</td>
				</tr>
				<tr>
					<td>Total de 50 programadores</td>
					<td>Posee una configuración fácil, que ayuda a la gestión en grupos pequeños</td>
					<td>Posee edición comunitaria, que presenta una gran ayuda a grandes grupos de ingenieros</td>
				</tr>
			</table>

			<h3>6.2 Situacion B</h3>
			<h4>6.2.1 Descripcion de la situacion</h4>
			<p>Descripción de la situación: Una gran empresa selecciona a 5000 de sus programadores para que realicen un software aplicando integración continua. Este equipo tan extenso, tendrá que dividirse el trabajo en tareas, para facilitar el desarrollo, y no importa qué lenguaje se utilice. El tiempo que tienen para realizar el software es de dos años, destacando que los últimos seis meses solo se podrá realizar comprobación de errores y solventarlos.</p>
			<h4>6.2.2 Recomendacion de la tecnología a utilizar</h4>
			<p>Se propone utilizar en esta ocasión GitLab. En este caso, GitLab es muchísimo mejor, porque se requiere centrarse más en la calidad del producto, que en la rapidez de creación. Por ello, y por el sistema de edición comunitaria, GitLab destaca frente a CircleCI.</p>
			<table>
				<tr>
					<th>Criterios</th>
					<th>Ventajas CircleCI</th>
					<th>Ventajas GitLab</th>
				</tr>
				<tr>
					<td>Total de 5000 programadores</td>
					<td>Posee una configuración fácil, que ayuda a la gestión en grupos pequeños</td>
					<td>Posee edición comunitaria, que presenta una gran ayuda a grandes grupos de ingenieros</td>
				</tr>
				<tr>
					<td>División del trabajo</td>
					<td>Posee un sistema de división del trabajo centrado en grupos pequeños</td>
					<td>Posee un sistema de división del trabajo centrado en grupos grandes</td>
				</tr>
				<tr>
					<td>Tiempo máxio 2 años</td>
					<td>Posee un sistema de compilación rápido, que ayuda a liberar rápidamente el código</td>
					<td>Su sistema se centra en la prueba, soporte y detección de errores</td>
				</tr>
			</table>
		</section>


	</main>

</body>

</html>